package com.ynet.life.sujrb.util;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEException;
import com.ynet.life.action.LifeJDBCAction;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Formatter;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import net.sf.json.JSONObject;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class WxAuthorizeUtil extends LifeJDBCAction {

   private static Log log = LogFactory.getLog(WxAuthorizeUtil.class);
   private static Map signInfoWx = null;


   public static String getSignInfoJson() throws Exception {
      String ret;
      if(!isNotBlank(ret = generateTicket())) {
         ret = cacheTicket();
      }

      if(isNotBlank(ret)) {
         return sign(ret);
      } else {
         JSONObject ret1;
         (ret1 = new JSONObject()).put("appId", "");
         ret1.put("nonceStr", "");
         ret1.put("timestamp", "");
         ret1.put("signature", "");
         ret1.put("ec", "1");
         ret1.put("em", "获取签名信息失败");
         return ret1.toString();
      }
   }

   private static String cacheTicket() throws Exception {
      String json = getToken();
      json = "https://api.weixin.qq.com/cgi-bin/ticket/getticket?access_token=" + json + "&type=jsapi";
      BufferedReader reader = null;
      boolean var15 = false;

      label99: {
         try {
            var15 = true;
            HttpURLConnection json1;
            (json1 = (HttpURLConnection)(new URL(json)).openConnection()).connect();
            reader = new BufferedReader(new InputStreamReader(json1.getInputStream()));
            StringBuilder buf = new StringBuilder();

            while((json = reader.readLine()) != null) {
               buf.append(json);
            }

            JSONObject json2 = JSONObject.fromObject(buf.toString());
            long createTime = System.currentTimeMillis() / 1000L;
            (signInfoWx = new HashMap()).put("ticket", json2.getString("ticket"));
            signInfoWx.put("expires_in", json2.getString("expires_in"));
            signInfoWx.put("createTime", Long.valueOf(createTime));
            json = json2.getString("ticket");
            var15 = false;
            break label99;
         } catch (Exception var19) {
            var19.printStackTrace();
            var15 = false;
         } finally {
            if(var15) {
               try {
                  if(reader != null) {
                     reader.close();
                  }
               } catch (IOException var16) {
                  var16.printStackTrace();
               }

            }
         }

         try {
            if(reader != null) {
               reader.close();
            }
         } catch (IOException var17) {
            var17.printStackTrace();
         }

         return null;
      }

      try {
         reader.close();
      } catch (IOException var18) {
         var18.printStackTrace();
      }

      return json;
   }

   private static String generateTicket() {
      String ret = "";
      if(signInfoWx != null && !signInfoWx.isEmpty()) {
         if(System.currentTimeMillis() / 1000L - ((Long)signInfoWx.get("createTime")).longValue() > Long.parseLong(signInfoWx.get("expires_in").toString())) {
            signInfoWx = null;
         } else {
            ret = (String)signInfoWx.get("ticket");
         }
      }

      return ret;
   }

   public static boolean isNotBlank(String str) {
      boolean isblank = true;
      if(str == null || "".equals(str)) {
         isblank = false;
      }

      return isblank;
   }

   public static String getToken() {
      String lines = "wx64628067f2386ee0";
      String reader = "9b9707db2cdeff8cff53302d75c0abbd";
      StringBuilder buf;
      (buf = new StringBuilder("https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=")).append(lines);
      buf.append("&secret=");
      buf.append(reader);
      BufferedReader reader1 = null;
      boolean var8 = false;

      label99: {
         try {
            var8 = true;
            HttpURLConnection lines1;
            (lines1 = (HttpURLConnection)(new URL(buf.toString())).openConnection()).connect();
            reader1 = new BufferedReader(new InputStreamReader(lines1.getInputStream()));
            buf = new StringBuilder();

            while((lines = reader1.readLine()) != null) {
               buf.append(lines);
            }

            lines = JSONObject.fromObject(buf.toString()).getString("access_token");
            var8 = false;
            break label99;
         } catch (Exception var12) {
            var12.printStackTrace();
            var8 = false;
         } finally {
            if(var8) {
               try {
                  if(reader1 != null) {
                     reader1.close();
                  }
               } catch (IOException var9) {
                  var9.printStackTrace();
               }

            }
         }

         try {
            if(reader1 != null) {
               reader1.close();
            }
         } catch (IOException var10) {
            var10.printStackTrace();
         }

         return null;
      }

      try {
         reader1.close();
      } catch (IOException var11) {
         var11.printStackTrace();
      }

      return lines;
   }

   public static String sign(String string1) throws UnsupportedEncodingException {
      JSONObject ret = new JSONObject();
      String nonce_str = create_nonce_str();
      String timestamp = create_timestamp();
      String signature = "";
      string1 = "jsapi_ticket=" + string1 + "&noncestr=" + nonce_str + "&timestamp=" + timestamp + "&url=http://www.szjr.suzhou.gov.cn/appfiles/main.html";
      log.info("string1=".concat(String.valueOf(string1)));

      try {
         MessageDigest crypt;
         (crypt = MessageDigest.getInstance("SHA-1")).reset();
         crypt.update(string1.getBytes("UTF-8"));
         signature = byteToHex(crypt.digest());
      } catch (NoSuchAlgorithmException var6) {
         var6.printStackTrace();
      } catch (UnsupportedEncodingException var7) {
         var7.printStackTrace();
      }

      ret.put("appId", "wx64628067f2386ee0");
      ret.put("nonceStr", nonce_str);
      ret.put("timestamp", timestamp);
      ret.put("signature", signature);
      ret.put("ec", "0");
      ret.put("em", "");
      return ret.toString();
   }

   private static String byteToHex(byte[] result) {
      Formatter formatter = new Formatter();
      byte[] var4 = result;
      int var3 = result.length;

      for(int var2 = 0; var2 < var3; ++var2) {
         byte var5 = var4[var2];
         formatter.format("%02x", new Object[]{Byte.valueOf(var5)});
      }

      String var6 = formatter.toString();
      formatter.close();
      return var6;
   }

   private static String create_nonce_str() {
      return UUID.randomUUID().toString();
   }

   private static String create_timestamp() {
      return Long.toString(System.currentTimeMillis() / 1000L);
   }

   public String execute(Context context) throws GENEException {
      try {
         context.setDataValue("wxAuthor", getSignInfoJson());
      } catch (Exception var2) {
         var2.printStackTrace();
      }

      return "0";
   }

   public static void main(String[] args) throws Exception {
      System.out.println(getSignInfoJson());
   }
}
